; div10.s
;
; Demo math routine(s).
;
; Mark J. Sebern
; MSOE
; 12 April 1994 (updated 13 December 1998)
;

        .area   ROMCODE (REL,CON)

; div10 - Subroutine to divide an unsigned 8-bit number by ten.
;
; Inputs:
;       A - Dividend.
;
; Outputs:
;       A - Quotient.
;       B - Remainder.
;       All other registers are preserved.
;
;
div10::
	pshx            ; Save register.

	ldx     #10     ; Load divisor.
	tab             ; Get dividend in D (AB).
	clra            ; Zero high byte of dividend.

	idiv            ; Do the division; quotient in X, remainder in D.

; Remainder is now in D; we only need the low byte, which is in B
; where we want it to be to return to our caller.

	pshx            ; Put quotient (16 bits) on stack.

; Quotient is on stack: high byte on top (low address), low byte next.
; Incrementing the SP now is the same as "pulling" a byte, but does
; not modify any register.

	ins             ; Discard high byte of quotient.
	pula            ; Get low byte of quotient in A.

	pulx            ; Restore register.

	rts
